<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: src/standard/containers/tiglContainersVertex.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_5c4eeb3f12cf4bfba980364a449079c1.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglContainersVertex.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglContainersVertex_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef TIGLVERTEX_HPP_</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define TIGLVERTEX_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//#include &quot;graph_struct.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;tiglContainersVertexTraits.hpp&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;types.h&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"></span><span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType = u<span class="keywordtype">int</span>32&gt;</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classvertex.html">   42</a></span>&#160;<span class="keyword">class </span><a class="code" href="classvertex.html">vertex</a>{</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">typedef</span> vertex_traits&lt;DataType, AlgDataType, EdgeType, IdType&gt; trait_type;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::ID_TYPE                            ID_TYPE;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span>  trait_type::OUT_EDGE_ITERATOR                 OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::OUT_EDGE_BUF                       OUT_EDGE_BUF;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::EDGE_TYPE                          EDGE_TYPE;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span>  trait_type::OUT_EDGE_ITERATOR                 EDGE_ITERATOR;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">typedef</span> AlgDataType                                             ALG_DATA_TYPE;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classvertex.html#acc18610f997b882cc447871819f3a7f0">   57</a></span>&#160;<span class="comment"></span>    <a class="code" href="classvertex.html#acc18610f997b882cc447871819f3a7f0">vertex</a>(IdType key) {<span class="keywordtype">id</span> = key;}</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    ~<a class="code" href="classvertex.html">vertex</a>() { }</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classvertex.html#acc60a3d4a79194de386251640bc8304c">   64</a></span>&#160;    IdType <a class="code" href="classvertex.html#acc60a3d4a79194de386251640bc8304c">id</a>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="classvertex.html#ad7d3f791514c0c4fafbe2f8f671ffae8">   67</a></span>&#160;    DataType    <a class="code" href="classvertex.html#ad7d3f791514c0c4fafbe2f8f671ffae8">vertexData</a>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classvertex.html#a140eb4cb64824b855f7c0a355861c421">   70</a></span>&#160;    AlgDataType <a class="code" href="classvertex.html#a140eb4cb64824b855f7c0a355861c421">algData</a>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classvertex.html#ae937679f3315f6494e0d21692d753939">   74</a></span>&#160;    OUT_EDGE_BUF <a class="code" href="classvertex.html#ae937679f3315f6494e0d21692d753939">outEdges</a>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">bool</span> operator&lt;(const vertex&lt;DataType, AlgDataType, EdgeType, IdType&gt; &amp; rhs) <span class="keyword">const</span> {    <span class="keywordflow">return</span> (<span class="keywordtype">id</span> &lt; rhs.id);}</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">bool</span> operator==(<span class="keyword">const</span> <a class="code" href="classvertex.html">vertex&lt;DataType, AlgDataType, EdgeType, IdType&gt;</a> &amp; rhs)<span class="keyword">const </span>{<span class="keywordflow">return</span> (<span class="keywordtype">id</span> == rhs.<a class="code" href="classvertex.html#acc60a3d4a79194de386251640bc8304c">id</a>);}</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="classvertex.html#aed3e52a8b910fb69eb2fb3b5dc355804">   85</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classvertex.html#aed3e52a8b910fb69eb2fb3b5dc355804">add_edge</a>(EdgeType &amp; x)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    {</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        outEdges.push_back(x);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    }</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="classvertex.html#a7cee60eb3a2149e2c0c8171d1948d9b4">   93</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classvertex.html#a7cee60eb3a2149e2c0c8171d1948d9b4">add_edge</a>(ID_TYPE &amp; target)</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    {</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        EDGE_TYPE newEdge(target);</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        outEdges.push_back(newEdge);</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    }</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="classvertex.html#a8d52a58a00fb99c18ea4b4878d99f50f">  102</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classvertex.html#a8d52a58a00fb99c18ea4b4878d99f50f">add_edge</a>(OUT_EDGE_BUF &amp; x) {</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = x.begin(); it != x.end(); ++it)</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                outEdges.push_back(*it);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    }</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classvertex.html#a8fbad4bba036f22d32b8981490bc7479">  111</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">bool</span> <a class="code" href="classvertex.html#a8fbad4bba036f22d32b8981490bc7479">remove_edge</a>(IdType &amp; target) {</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            <span class="keywordflow">if</span>(it-&gt;getNbr() == target)</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            {</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                outEdges.erase(it);</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            }</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    }</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="classvertex.html#a64fb1198fff6fe1044b77c3605acf876">  123</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classvertex.html#a64fb1198fff6fe1044b77c3605acf876">get_num_out_edges</a>() {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keywordflow">return</span> outEdges.size();</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    }</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="classvertex.html#aab1579d784f577a894b15a5f24458911">  129</a></span>&#160;<span class="comment"></span>    uint32 <a class="code" href="classvertex.html#aab1579d784f577a894b15a5f24458911">getNumDifferentNbr</a>() {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        uint32 numNbr = 0;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            <span class="keywordflow">if</span>(it-&gt;getNbr() != id)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;                numNbr++;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordflow">return</span> numNbr;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    }</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="classvertex.html#a2bcc0c3d992719b29f3f12528d81900b">  140</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classvertex.html#a2bcc0c3d992719b29f3f12528d81900b">get_children</a>(vector&lt;IdType&gt; &amp; vectChildren) {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            vectChildren.push_back(it-&gt;getNbr());</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="classvertex.html#a5fcc3ceabc778b7cbb3fdf0791be1403">  149</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">bool</span> <a class="code" href="classvertex.html#a5fcc3ceabc778b7cbb3fdf0791be1403">isConnected</a>(IdType node) {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            <span class="keywordflow">if</span>(it-&gt;getNbr() == node)</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    }</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00158"></a><span class="lineno"><a class="line" href="classvertex.html#af5d0a19bade61bb0cb3a221f22286a8d">  158</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> DataType &amp; <a class="code" href="classvertex.html#af5d0a19bade61bb0cb3a221f22286a8d">get_value</a>() {</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="keywordflow">return</span> vertexData;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    }</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="classvertex.html#a1b4a6dabec3f6b9251490194ef977f45">  164</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> AlgDataType &amp; <a class="code" href="classvertex.html#a1b4a6dabec3f6b9251490194ef977f45">getAlgData</a>() {</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="keywordflow">return</span> algData;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    }</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00170"></a><span class="lineno"><a class="line" href="classvertex.html#acf41c6b7e523f7b09d1794b4e50161fc">  170</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> IdType <a class="code" href="classvertex.html#acf41c6b7e523f7b09d1794b4e50161fc">getId</a>(){<span class="keywordflow">return</span> id;}</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00174"></a><span class="lineno"><a class="line" href="classvertex.html#a9d84fcd90980e82113bb99f1635b5921">  174</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> OUT_EDGE_ITERATOR <a class="code" href="classvertex.html#a9d84fcd90980e82113bb99f1635b5921">get_out_edge_iterator</a>(){ <span class="keywordflow">return</span> outEdges.begin();  }</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="classvertex.html#ad8b430cc4ba7c354e49753a648a9664c">  178</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> OUT_EDGE_ITERATOR <a class="code" href="classvertex.html#ad8b430cc4ba7c354e49753a648a9664c">get_end_out_edge_iterator</a>(){<span class="keywordflow">return</span> outEdges.end();}</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00184"></a><span class="lineno"><a class="line" href="classvertex.html#a020a35d8d33cf7164b7e40c682915d61">  184</a></span>&#160;<span class="comment"></span>    OUT_EDGE_ITERATOR <a class="code" href="classvertex.html#a020a35d8d33cf7164b7e40c682915d61">get_edge</a>(ID_TYPE target){</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;            <span class="keywordflow">if</span>(it-&gt;get_target() == target)</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                <span class="keywordflow">return</span> it;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        <span class="keywordflow">return</span> outEdges.end();</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    }</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="keywordtype">bool</span> is_bivertex(){<span class="keywordflow">return</span> <span class="keyword">false</span>;}</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="comment">//  /// core compute function: trivial realization in the core class. This function is overriden by the algorithm class</span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> compute(<span class="keywordtype">void</span> * pIn = 0, <span class="keywordtype">void</span> * pOut = 0) {<span class="keywordflow">return</span> <span class="keyword">false</span>;}</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment">//  /// core init function: trivial realization in the core class. This function is overriden by the algorithm class</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> init(){}</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    uint32 getEdgesSize()</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    {</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keywordflow">return</span> outEdges.capacity()*<span class="keyword">sizeof</span>(EdgeType);</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="comment">// dummy functions (not needed)</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keywordtype">void</span> add_in_edge(EdgeType &amp; x) {}</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordtype">void</span> add_in_edge(IdType &amp; src) {}</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordtype">void</span> add_in_edge(vector&lt;EdgeType&gt; &amp; x) {}</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <span class="keywordtype">void</span> remove_in_edge(IdType &amp; src) {}</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;};</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType = u<span class="keywordtype">int</span>32&gt;</div>
<div class="line"><a name="l00220"></a><span class="lineno"><a class="line" href="classbi__vertex.html">  220</a></span>&#160;<span class="keyword">class </span><a class="code" href="classbi__vertex.html">bi_vertex</a>:</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <span class="keyword">public</span> <a class="code" href="classvertex.html">vertex</a> &lt;DataType, AlgDataType, EdgeType, IdType&gt; {</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <span class="keyword">typedef</span> <a class="code" href="classvertex.html">vertex &lt;DataType, AlgDataType, EdgeType, IdType&gt;</a> <a class="code" href="classvertex.html">VERTEX_TYPE</a>;</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> VERTEX_TYPE::OUT_EDGE_ITERATOR EDGE_ITERATOR;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <span class="keyword">typedef</span> EDGE_ITERATOR IN_EDGE_ITERATOR;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="keyword">public</span>: <span class="comment">/*constructor/destructor*/</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    <a class="code" href="classbi__vertex.html">bi_vertex</a>(IdType key):<a class="code" href="classvertex.html">vertex&lt;DataType, AlgDataType, EdgeType, IdType&gt;</a>(key) {}</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    ~<a class="code" href="classbi__vertex.html">bi_vertex</a>() {  }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    vector&lt;EdgeType&gt; inEdges; <span class="comment">// hold the id&#39;s of the input edges and the src vertices</span></div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00237"></a><span class="lineno"><a class="line" href="classbi__vertex.html#a88758e8b179698fa320bad0d5beb74c0">  237</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classbi__vertex.html#a88758e8b179698fa320bad0d5beb74c0">add_in_edge</a>(EdgeType &amp; x) {</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        inEdges.push_back(x);</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    }</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div>
<div class="line"><a name="l00242"></a><span class="lineno"><a class="line" href="classbi__vertex.html#af0427b499810293f623370beb8ef850a">  242</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classbi__vertex.html#af0427b499810293f623370beb8ef850a">add_in_edge</a>(IdType &amp; src) {</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        EdgeType newEdge(src);</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        inEdges.push_back(newEdge);</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    }</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    <span class="comment">// adding input/outout edge(s)</span></div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keywordtype">void</span> add_in_edge(vector&lt;EdgeType&gt; &amp; x) {</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="keywordflow">for</span> (IN_EDGE_ITERATOR it = x.begin(); it != x.end(); ++it)</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                inEdges.push_back(*it);</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    }</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    <span class="keywordtype">void</span> remove_in_edge(IdType src) {</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        <span class="keywordflow">for</span>(IN_EDGE_ITERATOR it = inEdges.begin(); it != inEdges.end(); ++it)</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            <span class="keywordflow">if</span>(it-&gt;getNbr() == src)</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            {</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;                inEdges.erase(it);</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            }</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    }</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    uint32 get_num_in_edges() {</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        <span class="keywordflow">return</span> inEdges.size();</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    }</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div>
<div class="line"><a name="l00267"></a><span class="lineno"><a class="line" href="classbi__vertex.html#ad8d9af58a7f793657b332245077e93ee">  267</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classbi__vertex.html#ad8d9af58a7f793657b332245077e93ee">get_parents</a>(vector&lt;IdType&gt; &amp; vectParents) {</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keywordflow">for</span> (IN_EDGE_ITERATOR it = inEdges.begin(); it != inEdges.end(); ++it)</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            vectParents.push_back(it-&gt;getNbr());</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    }</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    uint32 getEdgesSize()</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    {</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        <span class="keywordflow">return</span> (inEdges.capacity()+ (this-&gt;outEdges).capacity())*<span class="keyword">sizeof</span>(EdgeType);</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    }</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    <span class="comment">/* returns pointer to the first edge*/</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    IN_EDGE_ITERATOR get_in_edge_iterator(){ <span class="keywordflow">return</span> inEdges.begin();    }</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    IN_EDGE_ITERATOR get_end_in_edge_iterator(){<span class="keywordflow">return</span> inEdges.end();}</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    <span class="keywordtype">bool</span> is_bivertex(){<span class="keywordflow">return</span> <span class="keyword">true</span>;} <span class="comment">// overrides base class function</span></div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;};</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="comment">/**********************************************************************************************</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="comment">**********************************************************************************************</span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;<span class="comment">**********************************************************************************************</span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="comment">**********************************************************************************************/</span></div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;<span class="comment"> * vertex_it: Vertex class with the output edge buffer containing iterators to the actual edges</span></div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;<span class="comment"> * !!!!!!!!!!!!! THIS REALIZATION HAS NOT BEEN TESTED YET</span></div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="comment"> * */</span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType&gt;</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="keyword">class </span>vertex_it{</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> set&lt;EdgeType&gt;::iterator    EDGE_ITERATOR;</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;EDGE_ITERATOR&gt;::itertor EDGE_BUF_ITERATOR;</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> EdgeType::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;<span class="keyword">public</span>: <span class="comment">/*constructor/destructor*/</span></div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    vertex_it(ID_TYPE key){<span class="keywordtype">id</span> = key; }</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    ~vertex_it() {  }</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    ID_TYPE id;</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="comment">//COLOR  color;</span></div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    DataType    vertexData;</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    AlgDataType algData;</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    vector&lt;EDGE_ITERATOR&gt;  outEdges; <span class="comment">// hold the id&#39;s of the out edges and target vertices</span></div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <span class="comment">/* operator overloading for adjacent list representation */</span></div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    <span class="keywordtype">bool</span> operator&lt;(vertex_it&lt;EdgeType, DataType, AlgDataType&gt; &amp; rhs){<span class="keywordflow">return</span>  (<span class="keywordtype">id</span> &lt; rhs.<a class="code" href="classvertex.html#acf41c6b7e523f7b09d1794b4e50161fc">getId</a>());}</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <span class="keywordtype">bool</span> operator==( vertex_it&lt;EdgeType, DataType, AlgDataType&gt; &amp; rhs){<span class="keywordflow">return</span>(<span class="keywordtype">id</span> == rhs.getId());}</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <span class="comment">// adding input/outout edge</span></div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    <span class="keywordtype">void</span> add_edge(EDGE_ITERATOR &amp;  x) { outEdges.push_back(x);}</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    <span class="comment">// adding input/outout edge(s)</span></div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    <span class="keywordtype">void</span> add_edge(vector&lt;EDGE_ITERATOR&gt; &amp; x) {</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;        <span class="keywordflow">for</span> (EDGE_BUF_ITERATOR it = x.begin(); it != x.end(); ++it)</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;                outEdges.push_back(*it);</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    }</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    <span class="keywordtype">bool</span> remove_edge(ID_TYPE target) {</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        <span class="keywordflow">for</span>(EDGE_BUF_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;            <span class="keywordflow">if</span>((*it)-&gt;get_target() == target)</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            {</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                outEdges.erase(it);</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;            }</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    }</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    <span class="keywordtype">bool</span> remove_edge(EDGE_ITERATOR &amp; edgeIt) {</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        <span class="keywordflow">for</span>(EDGE_BUF_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;            <span class="keywordflow">if</span>(*it == edgeIt)</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;            {</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;                outEdges.erase(it);</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;            }</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    }</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    <span class="keyword">inline</span> uint32 get_num_out_edges() {</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="keywordflow">return</span> outEdges.size();</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    }</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <span class="comment">// getting id of all children</span></div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> get_children(vector&lt;ID_TYPE&gt; &amp; vectChildren) {get_neighbors(vectChildren);}</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> get_neighbors(vector&lt;ID_TYPE&gt; &amp; vectChildren) {</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keywordflow">for</span> (EDGE_BUF_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;            vectChildren.push_back((*it)-&gt;get_target());</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    }</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    <span class="keywordtype">bool</span> is_connected(ID_TYPE node) {</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        <span class="keywordflow">for</span> (EDGE_BUF_ITERATOR it = outEdges.begin(); it != outEdges.end(); ++it)</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;            <span class="keywordflow">if</span>((*it)-&gt;get_target() == node)</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;    }</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    <span class="keyword">inline</span> DataType &amp; get_value() {</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        <span class="keywordflow">return</span> vertexData;</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    }</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;    <span class="keyword">inline</span> AlgDataType &amp; get_alg_data() {</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        <span class="keywordflow">return</span> algData;</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    }</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    <span class="comment">/* returns the vertex id*/</span></div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keyword">inline</span> ID_TYPE getId(){<span class="keywordflow">return</span> id;}</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    <span class="comment">/* returns pointer to the first edge*/</span></div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    <span class="keyword">inline</span> EDGE_BUF_ITERATOR get_out_edge_iterator(){ <span class="keywordflow">return</span> outEdges.begin();  }</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    <span class="keyword">inline</span> EDGE_BUF_ITERATOR get_end_out_edge_iterator(){<span class="keywordflow">return</span> outEdges.end();}</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> is_bivertex(){<span class="keywordflow">return</span> <span class="keyword">false</span>;}</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;    <span class="keywordtype">bool</span> compute(<span class="keywordtype">void</span> * pIn = 0, <span class="keywordtype">void</span> * pOut = 0) {<span class="keywordflow">return</span> <span class="keyword">false</span>;}</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> init(){}</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;    <span class="comment">/* the following two functions are meaningless but added for consistency*/</span></div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    <span class="keywordtype">void</span> add_in_edge(EDGE_ITERATOR &amp; x) {}</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;    <span class="keywordtype">void</span> add_in_edge(vector&lt;EDGE_ITERATOR&gt; &amp; x) {}</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;};</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;<span class="comment"> * The bi_vertex version of vertex_it: has an extra input edge buffer</span></div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;<span class="comment"> *!!!!!!!!!!!!! THIS REALIZATION HAS NOT BEEN TESTED YET</span></div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;<span class="comment"> * */</span></div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType&gt;</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="keyword">class </span>bi_vertex_it:</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    <span class="keyword">public</span> vertex_it &lt;EdgeType, DataType, AlgDataType&gt; {</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;EdgeType&gt;::iterator     EDGE_ITERATOR;</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;EDGE_ITERATOR&gt;::itertor EDGE_BUF_ITERATOR;</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> EdgeType::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;<span class="keyword">public</span>: <span class="comment">/*constructor/destructor*/</span></div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    bi_vertex_it(ID_TYPE key):vertex_it&lt;EdgeType, DataType, AlgDataType&gt;(key) {}</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;    ~bi_vertex_it() {   }</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    vector&lt;EDGE_ITERATOR&gt; inEdges; <span class="comment">// hold the id&#39;s of the input edges and the src vertices</span></div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    <span class="comment">// adding input/outout edge</span></div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;    <span class="keywordtype">void</span> add_in_edge(EDGE_ITERATOR &amp; x) {</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        inEdges.push_back(x);</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;    }</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;    <span class="comment">// adding input/outout edge(s)</span></div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;    <span class="keywordtype">void</span> add_in_edge(vector&lt;EDGE_ITERATOR&gt; &amp; x) {</div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;        <span class="keywordflow">for</span> (EDGE_BUF_ITERATOR it = x.begin(); it != x.end(); ++it)</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;                inEdges.push_back(*it);</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;    }</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;</div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;    <span class="keywordtype">void</span> remove_in_edge(ID_TYPE <span class="keywordtype">id</span>) {</div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        <span class="keywordflow">for</span>(EDGE_BUF_ITERATOR it = inEdges.begin(); it != inEdges.end(); ++it)</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;            <span class="keywordflow">if</span>((*it)-&gt;getId() == id)</div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;            {</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;                inEdges.erase(it);</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;            }</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;    }</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;</div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;    uint32 get_num_in_edges() {</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;        <span class="keywordflow">return</span> inEdges.size();</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;    }</div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;    <span class="comment">// getting id of all parents</span></div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;    <span class="keywordtype">void</span> get_parents(vector&lt;ID_TYPE&gt; &amp; vectParents) {</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;        <span class="keywordflow">for</span> (EDGE_BUF_ITERATOR it = inEdges.begin(); it != inEdges.end(); ++it)</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;            vectParents.push_back(*it-&gt;src);</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    }</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;    <span class="comment">/* returns pointer to the first edge*/</span></div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;    EDGE_BUF_ITERATOR get_in_edge_iterator(){ <span class="keywordflow">return</span> inEdges.begin();   }</div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;    EDGE_BUF_ITERATOR get_end_in_edge_iterator(){<span class="keywordflow">return</span> inEdges.end();}</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;    <span class="keywordtype">bool</span> is_bivertex(){<span class="keywordflow">return</span> <span class="keyword">true</span>;} <span class="comment">// overrides base class function</span></div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;};</div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="classvertex_html_a140eb4cb64824b855f7c0a355861c421"><div class="ttname"><a href="classvertex.html#a140eb4cb64824b855f7c0a355861c421">vertex::algData</a></div><div class="ttdeci">AlgDataType algData</div><div class="ttdoc">Algorithm-specific data. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:70</div></div>
<div class="ttc" id="classvertex_html_ad8b430cc4ba7c354e49753a648a9664c"><div class="ttname"><a href="classvertex.html#ad8b430cc4ba7c354e49753a648a9664c">vertex::get_end_out_edge_iterator</a></div><div class="ttdeci">OUT_EDGE_ITERATOR get_end_out_edge_iterator()</div><div class="ttdoc">returns an iterator to the last edge of the outEdges buffer </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:178</div></div>
<div class="ttc" id="classvertex_html_af5d0a19bade61bb0cb3a221f22286a8d"><div class="ttname"><a href="classvertex.html#af5d0a19bade61bb0cb3a221f22286a8d">vertex::get_value</a></div><div class="ttdeci">DataType &amp; get_value()</div><div class="ttdoc">return the vertex data field </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:158</div></div>
<div class="ttc" id="classvertex_html_a9d84fcd90980e82113bb99f1635b5921"><div class="ttname"><a href="classvertex.html#a9d84fcd90980e82113bb99f1635b5921">vertex::get_out_edge_iterator</a></div><div class="ttdeci">OUT_EDGE_ITERATOR get_out_edge_iterator()</div><div class="ttdoc">returns an iterator to the start of the outEdges buffer </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:174</div></div>
<div class="ttc" id="classbi__vertex_html"><div class="ttname"><a href="classbi__vertex.html">bi_vertex</a></div><div class="ttdoc">A vertex class with both input and output edges lists it inherits all the properties of regular verte...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:220</div></div>
<div class="ttc" id="classbi__vertex_html_af0427b499810293f623370beb8ef850a"><div class="ttname"><a href="classbi__vertex.html#af0427b499810293f623370beb8ef850a">bi_vertex::add_in_edge</a></div><div class="ttdeci">void add_in_edge(IdType &amp;src)</div><div class="ttdoc">adding input edge </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:242</div></div>
<div class="ttc" id="classvertex_html_a8fbad4bba036f22d32b8981490bc7479"><div class="ttname"><a href="classvertex.html#a8fbad4bba036f22d32b8981490bc7479">vertex::remove_edge</a></div><div class="ttdeci">bool remove_edge(IdType &amp;target)</div><div class="ttdoc">Removing an output edge identified by target node. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:111</div></div>
<div class="ttc" id="classbi__vertex_html_a88758e8b179698fa320bad0d5beb74c0"><div class="ttname"><a href="classbi__vertex.html#a88758e8b179698fa320bad0d5beb74c0">bi_vertex::add_in_edge</a></div><div class="ttdeci">void add_in_edge(EdgeType &amp;x)</div><div class="ttdoc">adding input edge </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:237</div></div>
<div class="ttc" id="classbi__vertex_html_ad8d9af58a7f793657b332245077e93ee"><div class="ttname"><a href="classbi__vertex.html#ad8d9af58a7f793657b332245077e93ee">bi_vertex::get_parents</a></div><div class="ttdeci">void get_parents(vector&lt; IdType &gt; &amp;vectParents)</div><div class="ttdoc">getting id of all parents </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:267</div></div>
<div class="ttc" id="classvertex_html_a2bcc0c3d992719b29f3f12528d81900b"><div class="ttname"><a href="classvertex.html#a2bcc0c3d992719b29f3f12528d81900b">vertex::get_children</a></div><div class="ttdeci">void get_children(vector&lt; IdType &gt; &amp;vectChildren)</div><div class="ttdoc">return the vertex id of all children </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:140</div></div>
<div class="ttc" id="classvertex_html_a64fb1198fff6fe1044b77c3605acf876"><div class="ttname"><a href="classvertex.html#a64fb1198fff6fe1044b77c3605acf876">vertex::get_num_out_edges</a></div><div class="ttdeci">uint32 get_num_out_edges()</div><div class="ttdoc">return the total number of output edges </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:123</div></div>
<div class="ttc" id="classvertex_html_a7cee60eb3a2149e2c0c8171d1948d9b4"><div class="ttname"><a href="classvertex.html#a7cee60eb3a2149e2c0c8171d1948d9b4">vertex::add_edge</a></div><div class="ttdeci">void add_edge(ID_TYPE &amp;target)</div><div class="ttdoc">adding output edge (overloaded function) </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:93</div></div>
<div class="ttc" id="classvertex_html_aed3e52a8b910fb69eb2fb3b5dc355804"><div class="ttname"><a href="classvertex.html#aed3e52a8b910fb69eb2fb3b5dc355804">vertex::add_edge</a></div><div class="ttdeci">void add_edge(EdgeType &amp;x)</div><div class="ttdoc">adding output edge </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:85</div></div>
<div class="ttc" id="classvertex_html_acc60a3d4a79194de386251640bc8304c"><div class="ttname"><a href="classvertex.html#acc60a3d4a79194de386251640bc8304c">vertex::id</a></div><div class="ttdeci">IdType id</div><div class="ttdoc">unique vertex ID </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:64</div></div>
<div class="ttc" id="classvertex_html_acf41c6b7e523f7b09d1794b4e50161fc"><div class="ttname"><a href="classvertex.html#acf41c6b7e523f7b09d1794b4e50161fc">vertex::getId</a></div><div class="ttdeci">IdType getId()</div><div class="ttdoc">returns the vertex id </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:170</div></div>
<div class="ttc" id="classvertex_html_aab1579d784f577a894b15a5f24458911"><div class="ttname"><a href="classvertex.html#aab1579d784f577a894b15a5f24458911">vertex::getNumDifferentNbr</a></div><div class="ttdeci">uint32 getNumDifferentNbr()</div><div class="ttdoc">returns the number of neigbors excluding self (i.e., ignoring self cycles) </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:129</div></div>
<div class="ttc" id="classvertex_html"><div class="ttname"><a href="classvertex.html">vertex</a></div><div class="ttdoc">core vertex class that contains all the vertex data and defines all vertex mutations It is a template...</div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:42</div></div>
<div class="ttc" id="classvertex_html_a1b4a6dabec3f6b9251490194ef977f45"><div class="ttname"><a href="classvertex.html#a1b4a6dabec3f6b9251490194ef977f45">vertex::getAlgData</a></div><div class="ttdeci">AlgDataType &amp; getAlgData()</div><div class="ttdoc">returns the algorithm data </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:164</div></div>
<div class="ttc" id="classvertex_html_a5fcc3ceabc778b7cbb3fdf0791be1403"><div class="ttname"><a href="classvertex.html#a5fcc3ceabc778b7cbb3fdf0791be1403">vertex::isConnected</a></div><div class="ttdeci">bool isConnected(IdType node)</div><div class="ttdoc">check if a given node is connected to the current node </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:149</div></div>
<div class="ttc" id="classvertex_html_acc18610f997b882cc447871819f3a7f0"><div class="ttname"><a href="classvertex.html#acc18610f997b882cc447871819f3a7f0">vertex::vertex</a></div><div class="ttdeci">vertex(IdType key)</div><div class="ttdoc">constructor assign the id </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:57</div></div>
<div class="ttc" id="classvertex_html_a020a35d8d33cf7164b7e40c682915d61"><div class="ttname"><a href="classvertex.html#a020a35d8d33cf7164b7e40c682915d61">vertex::get_edge</a></div><div class="ttdeci">OUT_EDGE_ITERATOR get_edge(ID_TYPE target)</div><div class="ttdoc">returns an iterator to the output edge with a given target </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:184</div></div>
<div class="ttc" id="classvertex_html_ad7d3f791514c0c4fafbe2f8f671ffae8"><div class="ttname"><a href="classvertex.html#ad7d3f791514c0c4fafbe2f8f671ffae8">vertex::vertexData</a></div><div class="ttdeci">DataType vertexData</div><div class="ttdoc">associated generic data </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:67</div></div>
<div class="ttc" id="classvertex_html_ae937679f3315f6494e0d21692d753939"><div class="ttname"><a href="classvertex.html#ae937679f3315f6494e0d21692d753939">vertex::outEdges</a></div><div class="ttdeci">OUT_EDGE_BUF outEdges</div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:74</div></div>
<div class="ttc" id="classvertex_html_a8d52a58a00fb99c18ea4b4878d99f50f"><div class="ttname"><a href="classvertex.html#a8d52a58a00fb99c18ea4b4878d99f50f">vertex::add_edge</a></div><div class="ttdeci">void add_edge(OUT_EDGE_BUF &amp;x)</div><div class="ttdoc">adding multiple ouput edges </div><div class="ttdef"><b>Definition:</b> tiglContainersVertex.hpp:102</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
